clear all; close all;

MAll=[1 4 16 256];    % number of blocks to be processed
M=max(MAll);
NPeriod=128;                     % length of a block
N=NPeriod*M;                    % Number of data points in the measurement
fs=NPeriod;                      % sampling frequency s.t. 1 period = 1 s
Ampl=1;                          % RMS-value of the multi sine
fGen=0.3*fs;                     % bandwidth excitation
NTrans=1024;                     % to eliminate transient effects

t=[0:NPeriod-1]/fs;             % time vector of 1 period
tAll=[0:N-1]/fs;                % time vector of full sequence
Lines=[1:NPeriod/2];            % select the lines to be plotted
f=[Lines-1]'/NPeriod*fs;        % frequency vector

[bGen,aGen]=butter(2,fGen/fs*2);
[bGen,aGen]=butter(3,0.35*2);
u=randn(N+NTrans,1)*Ampl; u=filter(bGen,aGen,u);
    
u(1:NTrans)=[]; u=reshape(u,NPeriod,M);
U=fft(u)/sqrt(NPeriod/2); U=U(Lines,:);
    
for k=length(MAll):-1:1, UU(:,k)=mean(abs(U(:,1:MAll(k))).^2,2); end
    
figure(1),subplot(1,4,1), stem(f,db(UU(:,1)/2)+40,'k'), title('M=1'); 
ylabel('Amplitud (dB)'); axis([0 60 0 60]); grid;
subplot(1,4,2), stem(f,db(UU(:,2)/2)+40,'k'), 
title('M=4'); axis([0 60 0 60]); grid;
subplot(1,4,3), stem(f,db(UU(:,3)/2)+40,'k'), 
title('M=16'); axis([0 60 0 60]); grid;
subplot(1,4,4), stem(f,db(UU(:,4)/2)+40,'k'), 
title('M=256'); axis([0 60 0 60]); grid;
ylabel('Amplitud (dB)'); xlabel('Frekvencia (Hz)'); 


 
 